function [xp, w] = generateparticles3(N)

%
% [xp, w] = generateparticles3(N)
%	
% 	xp	- particle positions
% 	w	- particle weights
%	
%	N	- Number of particles
%	
%
%  generateparticles3:
%     Generate a sample particle distribution, drawn from a specific
%     PDF. Find out which!
%     Strategy 3
%     
%     Mats Bengtsson,  1/10 2012
%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

xmax=10;
lambda=1/5;
xp=-log(rand(N,1))/lambda;
w_unnormalized=xp.*exp(lambda*xp)/lambda;
w_unnormalized(xp>xmax)=0;
w=w_unnormalized/sum(w_unnormalized);

