function [xp, w] = generateparticles4(N)

%
% [xp, w] = generateparticles4(N)
%	
% 	xp	- particle positions
% 	w	- particle weights
%	
%	N	- Number of particles
%	
%
%  generateparticles4:
%     Generate a sample particle distribution, drawn from a specific
%     PDF. Find out which!
%     Strategy 4
%     
%     Mats Bengtsson,  1/10 2012
%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

xmax=10;
sigma=7;
M=1.1*2/xmax/normpdf(xmax,0,sigma);
xp=sigma*randn(N,1);
u=rand(N,1);
rejected = (xp<0 | xp>xmax | u >= (2*xp/xmax^2 ./ normpdf(xp,0,sigma)/M));
while any(rejected)
  indices=find(rejected);
  Nrej=sum(rejected);
  xp_new=sigma*randn(Nrej,1);
  u=rand(Nrej,1);
  rejected_new = ...
      (xp_new<0 | xp_new>xmax | ...
       u >= (2*xp_new/xmax^2 ./ normpdf(xp_new,0,sigma)/M));
  rejected(indices)=rejected_new;
  xp(indices)=xp_new;
end
w=ones(N,1)/N;

